<?php

$plugin_info = array(
  'pi_name' => 'LiveJournal Format',
  'pi_version' => '1.0',
  'pi_author' => 'Yvonne',
  'pi_author_url' => 'http://www.ennovy.org/index/weblog/comments/livejournal_formatting_plugin',
  'pi_description' => 'Converts LiveJournal specific tags into HTML',
  'pi_usage' => Ljformat::usage()
  );

class Ljformat
{

var $return_data = "";

  function Ljformat()
  {

	global $TMPL;
  	global $FNS;
  	
  	// get parameters, set defaults if the parameters are not set
  	$cut = $TMPL->fetch_param('cut') ? $TMPL->fetch_param('cut') : 'false';
  	$path = $TMPL->fetch_param('path') ? $TMPL->fetch_param('path') : '';
  	$usericon = $TMPL->fetch_param('usericon') ? $TMPL->fetch_param('usericon') : 'http://stat.livejournal.com/img/userinfo.gif';
  	$commicon = $TMPL->fetch_param('commicon') ? $TMPL->fetch_param('commicon') : 'http://stat.livejournal.com/img/community.gif';
  	
  	$url = $FNS->create_url($path);
  	
  	// start replacing lj tags
	$patterns[0] = "/<lj user=\"([a-zA-Z_0-9]*)\">/i";
	$patterns[1] = "/<lj comm=\"([a-zA-Z_0-9]*)\">/i";
	$patterns[2] = "/<lj-cut text=\"(.*)\">(.*)<\/lj-cut>/isU";
	$patterns[3] = "/<lj-cut>(.*)<\/lj-cut>/isU";
	
	$replacements[0] = "<span class=\"ljuser\" style=\"white-space: nowrap;\"><a href=\"http://www.livejournal.com/userinfo.bml?user=$1\"><img src=\"".$usericon."\" alt=\"[info]\" style=\"border: 0pt none; vertical-align: bottom;\" height=\"17\" width=\"17\"></a><a href=\"http://www.livejournal.com/users/$1\"><b>$1</b></a></span>";
	$replacements[1] = "<span class=\"ljuser\" style=\"white-space: nowrap;\"><a href=\"http://www.livejournal.com/userinfo.bml?user=$1\"><img src=\"".$commicon."\" alt=\"[info]\" style=\"border: 0pt none; vertical-align: bottom;\" height=\"17\" width=\"17\"></a><a href=\"http://www.livejournal.com/community/$1\"><b>$1</b></a></span>";
	if ( $cut == "true" ) {
		$replacements[2] = "<b>( <a href=\"".$url."\">$1</a> )</b>";
		$replacements[3] = "<b>( <a href=\"".$url."\">Read more...</a> )</b>";
	}
	else {
		$replacements[2] = "$2";
		$replacements[3] = "$1";
	}
	
	$str1 = preg_replace($patterns, $replacements, $TMPL->tagdata);
		
	$this->return_data = $str1;	
	       
  }

  // ----------------------------------------
  //  Plugin Usage
  // ----------------------------------------

  // This function describes how the plugin is used.
  //  Make sure and use output buffering

  function usage()
  {
  ob_start(); 
  ?>
  	GENERAL
  	
	This plugin replaces the LiveJournal-specific tags with their HTML equivalents. It supports the <lj user>, <lj comm>, and <lj-cut> tags.
	
	Learn more about how to use these tags at this page: http://www.livejournal.com/support/faqbrowse.bml?faqid=75
	
	Note that for the <lj-cut> tags to work, there MUST be a closing </lj-cut> tag, e.g. <lj-cut> ... </lj-cut>.
	
	You can enable or disable the use of the <lj-cut> tag by using the parameters, described below.
	
	PARAMETERS
	
	cut="" - by default, the plugin will NOT replace anything between <lj-cut> tags with a link. It will simply strip away the <lj-cut> tags, as they are not valid HTML. In order to replace anything between the <lj-cut> tags with a link, you have to specify this parameter and set it to "true".
	
	path="" - this parameter is needed only when you have set the "cut" parameter to "true". With this parameter, you can specify the path to your comments page - where the <lj-cut> tag will link to. If this parameter is not set, the link will default to the site home page.
	
	usericon="" - with this parameter, you can specify the URL of the image that is used for the user info. It defaults to the image at http://stat.livejournal.com/img/userinfo.gif.
	
	commicon="" - with this parameter, you can specify the URL of the image that is used for the community info. It defaults to the image at http://stat.livejournal.com/img/community.gif.
	
	USAGE
	
	Surround the text that contains the LJ-specific tags with the tag pair {exp:ljformat}{/exp:ljformat}, e.g.
	
	{exp:ljformat}
	Hello, my name is Mr. X and my LiveJournal is at <lj user="mrx">.
	{/exp:ljformat}	
	
	EXAMPLE
	
	When used with the weblog entries tag on your main page:
	{exp:weblog:entries weblog="weblog1" limit="15"}
	<h3>{title}</h3>
	{exp:ljformat cut="true" path="weblog/comments/{url_title}"}
	{body}
	{/exp:ljformat}
	<div>Last updated on {edit_date format='%M %d, %Y'} at {edit_date format='%h:%i %A'}<br />
	</div>
	{/exp:weblog:entries}
	
	When used on your comments page:
	{exp:weblog:entries weblog="weblog1" limit="1"}
	<h3>{title}</h3>
	{exp:ljformat cut="false"}
	{body}
	{/exp:ljformat}
	<div>Last updated on {edit_date format='%M %d, %Y'} at {edit_date format='%h:%i %A'}<br />
	</div>
	{/exp:weblog:entries}	

  <?php
  $buffer = ob_get_contents();
  
  ob_end_clean(); 

  return $buffer;
  }
  // END

}

?>